# -- DO NOT EDIT THIS FILE DIRECTLY --
"""
Base class for Delay
This file was auto-generated by genrv.
"""

from enum import IntEnum

from rv.controller import Controller, DependentRange, WarnOnlyRange


class BaseDelay:
    name = "Delay"
    mtype = "Delay"
    mgroup = "Effect"
    flags = default_flags = 0x451

    class Channels(IntEnum):
        stereo = 0
        mono = 1

    class DelayUnit(IntEnum):
        sec_div_16384 = 0
        ms = 1
        hz = 2
        tick = 3
        line = 4
        line_div_2 = 5
        line_div_3 = 6
        sec_div_44100 = 7
        sec_div_48000 = 8
        sample = 9

    dry = Controller((0, 512), 256)
    wet = Controller((0, 512), 256)
    delay_l = Controller(
        DependentRange(
            "delay_unit",
            {
                DelayUnit.sec_div_16384: WarnOnlyRange(0, 256),
                DelayUnit.ms: WarnOnlyRange(0, 4000),
                DelayUnit.hz: WarnOnlyRange(0, 8192),
                DelayUnit.tick: WarnOnlyRange(0, 256),
                DelayUnit.line: WarnOnlyRange(0, 256),
                DelayUnit.line_div_2: WarnOnlyRange(0, 256),
                DelayUnit.line_div_3: WarnOnlyRange(0, 256),
                DelayUnit.sec_div_44100: WarnOnlyRange(0, 32768),
                DelayUnit.sec_div_48000: WarnOnlyRange(0, 32768),
                DelayUnit.sample: WarnOnlyRange(0, 32768),
            },
            WarnOnlyRange(0, 256),
        ),
        128,
    )
    delay_r = Controller(
        DependentRange(
            "delay_unit",
            {
                DelayUnit.sec_div_16384: WarnOnlyRange(0, 256),
                DelayUnit.ms: WarnOnlyRange(0, 4000),
                DelayUnit.hz: WarnOnlyRange(0, 8192),
                DelayUnit.tick: WarnOnlyRange(0, 256),
                DelayUnit.line: WarnOnlyRange(0, 256),
                DelayUnit.line_div_2: WarnOnlyRange(0, 256),
                DelayUnit.line_div_3: WarnOnlyRange(0, 256),
                DelayUnit.sec_div_44100: WarnOnlyRange(0, 32768),
                DelayUnit.sec_div_48000: WarnOnlyRange(0, 32768),
                DelayUnit.sample: WarnOnlyRange(0, 32768),
            },
            WarnOnlyRange(0, 256),
        ),
        160,
    )
    volume_l = Controller((0, 256), 256)
    volume_r = Controller((0, 256), 256)
    channels = Controller(Channels, Channels.stereo)
    inverse = Controller(bool, False)
    delay_unit = Controller(DelayUnit, DelayUnit.sec_div_16384)
    delay_multiplier = Controller((1, 15), 1)
    feedback = Controller((0, 32768), 0)
    negative_feedback = Controller(bool, False)
    all_pass_filter = Controller(bool, False)
