# -- DO NOT EDIT THIS FILE DIRECTLY --
"""
Base class for Fft
This file was auto-generated by genrv.
"""

from enum import IntEnum

from rv.controller import Controller


class BaseFft:
    name = "Fft"
    mtype = "FFT"
    mgroup = "Effect"
    flags = default_flags = 0x51

    class SampleRate(IntEnum):
        _8000hz = 0
        _11025hz = 1
        _16000hz = 2
        _22050hz = 3
        _32000hz = 4
        _44100hz = 5
        _48000hz = 6
        _88200hz = 7
        _96000hz = 8
        _119200hz = 9

    class Channels(IntEnum):
        mono = 0
        stereo = 1

    class Buffer(IntEnum):
        _64 = 0
        _128 = 1
        _256 = 2
        _512 = 3
        _1024 = 4
        _2048 = 5
        _4096 = 6
        _8192 = 7

    class BufferOverlap(IntEnum):
        _0 = 0
        _2x = 1
        _4x = 2

    sample_rate = Controller(SampleRate, SampleRate._44100hz)
    channels = Controller(Channels, Channels.mono)
    buffer = Controller(Buffer, Buffer._1024)
    buf_overlap = Controller(BufferOverlap, BufferOverlap._2x)
    feedback = Controller((0, 32768), 0)
    noise_reduction = Controller((0, 32768), 0)
    phase_gain = Controller((0, 32768), 16384)
    all_pass_filter = Controller((0, 32768), 0)
    frequency_spread = Controller((0, 32768), 0)
    random_phase = Controller((0, 32768), 0)
    random_phase_lite = Controller((0, 32768), 0)
    freq_shift = Controller((-4096, 4096), 0)
    deform1 = Controller((0, 32768), 0)
    deform2 = Controller((0, 32768), 0)
    hp_cutoff = Controller((0, 32768), 0)
    lp_cutoff = Controller((0, 32768), 32768)
    volume = Controller((0, 32768), 32768)
