# -- DO NOT EDIT THIS FILE DIRECTLY --
"""
Base class for Lfo
This file was auto-generated by genrv.
"""

from enum import IntEnum

from rv.controller import Controller, DependentRange, WarnOnlyRange


class BaseLfo:
    name = "Lfo"
    mtype = "LFO"
    mgroup = "Effect"
    flags = default_flags = 0x451

    class Type(IntEnum):
        amplitude = 0
        panning = 1

    class Waveform(IntEnum):
        sin = 0
        square = 1
        sin2 = 2
        saw = 3
        saw2 = 4
        random = 5
        triangle = 6
        random_interpolated = 7

    class Channels(IntEnum):
        stereo = 0
        mono = 1

    class FrequencyUnit(IntEnum):
        hz_div_64 = 0
        ms = 1
        hz = 2
        tick = 3
        line = 4
        line_div_2 = 5
        line_div_3 = 6

    class SmoothTransitions(IntEnum):
        off = 0
        waveform = 1

    class SineQuality(IntEnum):
        auto = 0
        low = 1
        middle = 2
        high = 3

    volume = Controller((0, 512), 256)
    type = Controller(Type, Type.amplitude)
    amplitude = Controller((0, 256), 256)
    freq = Controller(
        DependentRange(
            "frequency_unit",
            {
                FrequencyUnit.hz_div_64: WarnOnlyRange(1, 2048),
                FrequencyUnit.ms: WarnOnlyRange(1, 4000),
                FrequencyUnit.hz: WarnOnlyRange(1, 16384),
                FrequencyUnit.tick: WarnOnlyRange(1, 256),
                FrequencyUnit.line: WarnOnlyRange(1, 256),
                FrequencyUnit.line_div_2: WarnOnlyRange(1, 256),
                FrequencyUnit.line_div_3: WarnOnlyRange(1, 256),
            },
            WarnOnlyRange(1, 2048),
        ),
        256,
    )
    waveform = Controller(Waveform, Waveform.sin2)
    set_phase = Controller((0, 256), 0)
    channels = Controller(Channels, Channels.stereo)
    frequency_unit = Controller(FrequencyUnit, FrequencyUnit.hz_div_64)
    duty_cycle = Controller((0, 256), 128)
    generator = Controller(bool, False)
    freq_scale = Controller((0, 200), 100)
    smooth_transitions = Controller(SmoothTransitions, SmoothTransitions.waveform)
    sine_quality = Controller(SineQuality, SineQuality.auto)
