# -- DO NOT EDIT THIS FILE DIRECTLY --
"""
Base class for Loop
This file was auto-generated by genrv.
"""

from enum import IntEnum

from rv.controller import Controller, DependentRange, WarnOnlyRange


class BaseLoop:
    name = "Loop"
    mtype = "Loop"
    mgroup = "Effect"
    flags = default_flags = 0x451

    class Channels(IntEnum):
        mono = 0
        stereo = 1

    class Mode(IntEnum):
        normal = 0
        ping_pong = 1

    class LengthUnit(IntEnum):
        line_div_128 = 0
        line = 1
        line_div_2 = 2
        line_div_3 = 3
        tick = 4
        ms = 5
        hz = 6

    class OnNoteOn(IntEnum):
        restart = 0
        restart_current_iteration = 1

    volume = Controller((0, 256), 256)
    length = Controller(
        DependentRange(
            "length_unit",
            {
                LengthUnit.line_div_128: WarnOnlyRange(0, 256),
                LengthUnit.line: WarnOnlyRange(0, 8192),
                LengthUnit.line_div_2: WarnOnlyRange(0, 8192),
                LengthUnit.line_div_3: WarnOnlyRange(0, 8192),
                LengthUnit.tick: WarnOnlyRange(0, 8192),
                LengthUnit.ms: WarnOnlyRange(0, 8192),
                LengthUnit.hz: WarnOnlyRange(0, 8192),
            },
            WarnOnlyRange(0, 256),
        ),
        256,
    )
    channels = Controller(Channels, Channels.stereo)
    repeats = Controller((0, 128), 0)
    mode = Controller(Mode, Mode.normal)
    length_unit = Controller(LengthUnit, LengthUnit.line_div_128)
    max_buffer_size = Controller((1, 240), 4)
    on_note_on = Controller(OnNoteOn, OnNoteOn.restart)
