# -- DO NOT EDIT THIS FILE DIRECTLY --
"""
Base class for PitchDetector
This file was auto-generated by genrv.
"""

from enum import IntEnum

from rv.controller import Controller


class BasePitchDetector:
    name = "PitchDetector"
    mtype = "Pitch Detector"
    mgroup = "Misc"
    flags = default_flags = 0x860051

    class Algorithm(IntEnum):
        zero_crossing = 0
        autocorrelation = 1
        cepstrum = 2
        spectral_peak = 3

    class RollOff(IntEnum):
        _12db = 0
        _24db = 1
        _36db = 2
        _48db = 3

    class SampleRate(IntEnum):
        _12000hz = 0
        _24000hz = 1
        _44100hz = 2

    class Buffer(IntEnum):
        _5ms = 0
        _10ms = 1
        _21ms = 2
        _42ms = 3
        _85ms = 4

    algorithm = Controller(Algorithm, Algorithm.autocorrelation)
    threshold = Controller((0, 10000), 80)
    gain = Controller((0, 256), 0)
    microtones = Controller(bool, True)
    detector_finetune = Controller((-256, 256), 0)
    lp_filter_freq = Controller((0, 4000), 1000)
    lp_filter_rolloff = Controller(RollOff, RollOff._12db)
    alg_1_2_sample_rate = Controller(SampleRate, SampleRate._12000hz)
    alg_1_2_buffer = Controller(Buffer, Buffer._21ms)
    alg_1_2_buffer_overlap = Controller((0, 100), 50)
    alg_1_sensitivity = Controller((0, 100), 10)
    record_notes = Controller(bool, False)
