/**
 * -- DO NOT EDIT THIS FILE DIRECTLY --
 *
 * This file was auto-generated by genrv.
 */
import { MidiMap, ControllerMidiMap, ControllerMidiMaps } from "../controllerMidiMap"
import { Project } from "../project"
import { ModuleBase } from "./moduleBase"
import { ModuleType, OptionValues, Options } from "./moduleType"
import { DcBlockerBehavior } from "./dcBlockerBehavior"
import { DcBlockerControllers } from "./dcBlockerControllers"
import { DcBlockerControllerValues } from "./dcBlockerControllerValues"
export namespace DcBlocker {
  // Intentionally duplicated enums - see also dcBlockerEnums.ts
  // (TypeScript does not allow exporting imported enums from inside a namespace)
  export enum Channels {
    // noinspection JSUnusedGlobalSymbols
    Stereo = 0,
    Mono = 1,
  }
  export enum CtlNum {
    Channels = 1,
  }
  interface DcBlockerControllerMidiMaps extends ControllerMidiMaps {
    channels: ControllerMidiMap
  }
  interface DcBlockerOptionValues extends OptionValues {}
  class DcBlockerOptions implements Options {
    constructor(readonly optionValues: DcBlockerOptionValues) {}
  }
  export class Module extends ModuleBase implements ModuleType {
    name = "DC Blocker"
    flags = 0x51
    readonly typeName = "DC Blocker"
    readonly controllerSetters = [
      (val: number) => {
        this.controllerValues.channels = val
      },
    ]
    readonly controllerValues: DcBlockerControllerValues = {
      channels: Channels.Stereo,
    }
    readonly controllers: DcBlockerControllers = new DcBlockerControllers(
      this,
      this.controllerValues
    )
    readonly c = this.controllers
    readonly midiMaps: DcBlockerControllerMidiMaps = {
      channels: new ControllerMidiMap(),
    }
    readonly optionValues: DcBlockerOptionValues = {}
    readonly options: DcBlockerOptions = new DcBlockerOptions(this.optionValues)
    readonly o = this.options
    behavior?: DcBlockerBehavior
    constructor() {
      super()
      this.behavior = new DcBlockerBehavior(this)
    }
    attachTo(project: Project): AttachedModule {
      return super.attachTo(project) as AttachedModule
    }
    setRawControllerValue(ctlNum: number, value: number) {
      const { controllerValues: cv } = this
      switch (ctlNum) {
        case 1:
          cv.channels = value
          break
      }
    }
    *rawControllerValues(): Generator<number> {
      const { controllerValues: cv } = this
      yield cv.channels
    }
    setMidiMaps(midiMaps: MidiMap[]) {
      this.midiMaps.channels = midiMaps[0] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
    }
    midiMapsArray(): MidiMap[] {
      const a: MidiMap[] = []
      a.push(this.midiMaps.channels)
      return a
    }
  }
  export class AttachedModule extends Module {
    get index(): number {
      if (this._index === undefined) {
        throw new Error("Attached module has empty index")
      }
      return this._index
    }
    set index(_: number) {
      throw new Error("Module index can only be assigned once")
    }
  }
}
