/**
 * -- DO NOT EDIT THIS FILE DIRECTLY --
 *
 * This file was auto-generated by genrv.
 */
import { MidiMap, ControllerMidiMap, ControllerMidiMaps } from "../controllerMidiMap"
import { Project } from "../project"
import { ModuleBase } from "./moduleBase"
import { ModuleType, OptionValues, Options } from "./moduleType"
import { FilterBehavior } from "./filterBehavior"
import { FilterControllers } from "./filterControllers"
import { FilterControllerValues } from "./filterControllerValues"
export namespace Filter {
  // Intentionally duplicated enums - see also filterEnums.ts
  // (TypeScript does not allow exporting imported enums from inside a namespace)
  export enum Type {
    // noinspection JSUnusedGlobalSymbols
    Lp = 0,
    Hp = 1,
    Bp = 2,
    Notch = 3,
  }
  export enum Mode {
    // noinspection JSUnusedGlobalSymbols
    Hq = 0,
    HqMono = 1,
    Lq = 2,
    LqMono = 3,
  }
  export enum RollOff {
    // noinspection JSUnusedGlobalSymbols
    _12db = 0,
    _24db = 1,
    _36db = 2,
    _48db = 3,
  }
  export enum LfoFreqUnit {
    // noinspection JSUnusedGlobalSymbols
    HzMul_0_02 = 0,
    Ms = 1,
    Hz = 2,
    Tick = 3,
    Line = 4,
    LineDiv_2 = 5,
    LineDiv_3 = 6,
  }
  export enum LfoWaveform {
    // noinspection JSUnusedGlobalSymbols
    Sin = 0,
    Saw = 1,
    Saw2 = 2,
    Square = 3,
    Random = 4,
  }
  export enum CtlNum {
    Volume = 1,
    Freq = 2,
    Resonance = 3,
    Type = 4,
    Response = 5,
    Mode = 6,
    Impulse = 7,
    Mix = 8,
    LfoFreq = 9,
    LfoAmp = 10,
    SetLfoPhase = 11,
    ExponentialFreq = 12,
    RollOff = 13,
    LfoFreqUnit = 14,
    LfoWaveform = 15,
  }
  interface FilterControllerMidiMaps extends ControllerMidiMaps {
    volume: ControllerMidiMap
    freq: ControllerMidiMap
    resonance: ControllerMidiMap
    type: ControllerMidiMap
    response: ControllerMidiMap
    mode: ControllerMidiMap
    impulse: ControllerMidiMap
    mix: ControllerMidiMap
    lfoFreq: ControllerMidiMap
    lfoAmp: ControllerMidiMap
    setLfoPhase: ControllerMidiMap
    exponentialFreq: ControllerMidiMap
    rollOff: ControllerMidiMap
    lfoFreqUnit: ControllerMidiMap
    lfoWaveform: ControllerMidiMap
  }
  interface FilterOptionValues extends OptionValues {}
  class FilterOptions implements Options {
    constructor(readonly optionValues: FilterOptionValues) {}
  }
  export class Module extends ModuleBase implements ModuleType {
    name = "Filter"
    flags = 0x451
    readonly typeName = "Filter"
    readonly controllerSetters = [
      (val: number) => {
        this.controllerValues.volume = val
      },
      (val: number) => {
        this.controllerValues.freq = val
      },
      (val: number) => {
        this.controllerValues.resonance = val
      },
      (val: number) => {
        this.controllerValues.type = val
      },
      (val: number) => {
        this.controllerValues.response = val
      },
      (val: number) => {
        this.controllerValues.mode = val
      },
      (val: number) => {
        this.controllerValues.impulse = val
      },
      (val: number) => {
        this.controllerValues.mix = val
      },
      (val: number) => {
        this.controllerValues.lfoFreq = val
      },
      (val: number) => {
        this.controllerValues.lfoAmp = val
      },
      (val: number) => {
        this.controllerValues.setLfoPhase = val
      },
      (val: number) => {
        this.controllerValues.exponentialFreq = Boolean(val)
      },
      (val: number) => {
        this.controllerValues.rollOff = val
      },
      (val: number) => {
        this.controllerValues.lfoFreqUnit = val
      },
      (val: number) => {
        this.controllerValues.lfoWaveform = val
      },
    ]
    readonly controllerValues: FilterControllerValues = {
      volume: 256,
      freq: 14000,
      resonance: 0,
      type: Type.Lp,
      response: 8,
      mode: Mode.Hq,
      impulse: 0,
      mix: 256,
      lfoFreq: 8,
      lfoAmp: 0,
      setLfoPhase: 0,
      exponentialFreq: false,
      rollOff: RollOff._12db,
      lfoFreqUnit: LfoFreqUnit.HzMul_0_02,
      lfoWaveform: LfoWaveform.Sin,
    }
    readonly controllers: FilterControllers = new FilterControllers(
      this,
      this.controllerValues
    )
    readonly c = this.controllers
    readonly midiMaps: FilterControllerMidiMaps = {
      volume: new ControllerMidiMap(),
      freq: new ControllerMidiMap(),
      resonance: new ControllerMidiMap(),
      type: new ControllerMidiMap(),
      response: new ControllerMidiMap(),
      mode: new ControllerMidiMap(),
      impulse: new ControllerMidiMap(),
      mix: new ControllerMidiMap(),
      lfoFreq: new ControllerMidiMap(),
      lfoAmp: new ControllerMidiMap(),
      setLfoPhase: new ControllerMidiMap(),
      exponentialFreq: new ControllerMidiMap(),
      rollOff: new ControllerMidiMap(),
      lfoFreqUnit: new ControllerMidiMap(),
      lfoWaveform: new ControllerMidiMap(),
    }
    readonly optionValues: FilterOptionValues = {}
    readonly options: FilterOptions = new FilterOptions(this.optionValues)
    readonly o = this.options
    behavior?: FilterBehavior
    constructor() {
      super()
      this.behavior = new FilterBehavior(this)
    }
    attachTo(project: Project): AttachedModule {
      return super.attachTo(project) as AttachedModule
    }
    setRawControllerValue(ctlNum: number, value: number) {
      const { controllerValues: cv } = this
      switch (ctlNum) {
        case 1:
          cv.volume = value
          break
        case 2:
          cv.freq = value
          break
        case 3:
          cv.resonance = value
          break
        case 4:
          cv.type = value
          break
        case 5:
          cv.response = value
          break
        case 6:
          cv.mode = value
          break
        case 7:
          cv.impulse = value
          break
        case 8:
          cv.mix = value
          break
        case 9:
          cv.lfoFreq = value
          break
        case 10:
          cv.lfoAmp = value
          break
        case 11:
          cv.setLfoPhase = value
          break
        case 12:
          cv.exponentialFreq = Boolean(value)
          break
        case 13:
          cv.rollOff = value
          break
        case 14:
          cv.lfoFreqUnit = value
          break
        case 15:
          cv.lfoWaveform = value
          break
      }
    }
    *rawControllerValues(): Generator<number> {
      const { controllerValues: cv } = this
      yield cv.volume
      yield cv.freq
      yield cv.resonance
      yield cv.type
      yield cv.response
      yield cv.mode
      yield cv.impulse
      yield cv.mix
      yield cv.lfoFreq
      yield cv.lfoAmp
      yield cv.setLfoPhase
      yield Number(cv.exponentialFreq)
      yield cv.rollOff
      yield cv.lfoFreqUnit
      yield cv.lfoWaveform
    }
    setMidiMaps(midiMaps: MidiMap[]) {
      this.midiMaps.volume = midiMaps[0] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.freq = midiMaps[1] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.resonance = midiMaps[2] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.type = midiMaps[3] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.response = midiMaps[4] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.mode = midiMaps[5] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.impulse = midiMaps[6] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.mix = midiMaps[7] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.lfoFreq = midiMaps[8] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.lfoAmp = midiMaps[9] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.setLfoPhase = midiMaps[10] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.exponentialFreq = midiMaps[11] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.rollOff = midiMaps[12] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.lfoFreqUnit = midiMaps[13] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.lfoWaveform = midiMaps[14] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
    }
    midiMapsArray(): MidiMap[] {
      const a: MidiMap[] = []
      a.push(this.midiMaps.volume)
      a.push(this.midiMaps.freq)
      a.push(this.midiMaps.resonance)
      a.push(this.midiMaps.type)
      a.push(this.midiMaps.response)
      a.push(this.midiMaps.mode)
      a.push(this.midiMaps.impulse)
      a.push(this.midiMaps.mix)
      a.push(this.midiMaps.lfoFreq)
      a.push(this.midiMaps.lfoAmp)
      a.push(this.midiMaps.setLfoPhase)
      a.push(this.midiMaps.exponentialFreq)
      a.push(this.midiMaps.rollOff)
      a.push(this.midiMaps.lfoFreqUnit)
      a.push(this.midiMaps.lfoWaveform)
      return a
    }
  }
  export class AttachedModule extends Module {
    get index(): number {
      if (this._index === undefined) {
        throw new Error("Attached module has empty index")
      }
      return this._index
    }
    set index(_: number) {
      throw new Error("Module index can only be assigned once")
    }
  }
}
