/**
 * -- DO NOT EDIT THIS FILE DIRECTLY --
 *
 * This file was auto-generated by genrv.
 */
import { MidiMap, ControllerMidiMap, ControllerMidiMaps } from "../controllerMidiMap"
import { Project } from "../project"
import { ModuleBase } from "./moduleBase"
import { ModuleType, OptionValues, Options } from "./moduleType"
import { FilterProBehavior } from "./filterProBehavior"
import { FilterProControllers } from "./filterProControllers"
import { FilterProControllerValues } from "./filterProControllerValues"
export namespace FilterPro {
  // Intentionally duplicated enums - see also filterProEnums.ts
  // (TypeScript does not allow exporting imported enums from inside a namespace)
  export enum Type {
    // noinspection JSUnusedGlobalSymbols
    Lp = 0,
    Hp = 1,
    BpConstSkirtGain = 2,
    BpConstPeakGain = 3,
    Notch = 4,
    AllPass = 5,
    Peaking = 6,
    LowShelf = 7,
    HighShelf = 8,
    Lp_6db = 9,
    Hp_6db = 10,
  }
  export enum RollOff {
    // noinspection JSUnusedGlobalSymbols
    _12db = 0,
    _24db = 1,
    _36db = 2,
    _48db = 3,
    _60db = 4,
    _72db = 5,
    _84db = 6,
    _96db = 7,
  }
  export enum Mode {
    // noinspection JSUnusedGlobalSymbols
    Stereo = 0,
    Mono = 1,
    StereoSmoothing = 2,
    MonoSmoothing = 3,
  }
  export enum LfoWaveform {
    // noinspection JSUnusedGlobalSymbols
    Sin = 0,
    Saw = 1,
    Saw2 = 2,
    Square = 3,
    Random = 4,
  }
  export enum LfoFreqUnit {
    // noinspection JSUnusedGlobalSymbols
    HzMul_0_02 = 0,
    Ms = 1,
    Hz = 2,
    Tick = 3,
    Line = 4,
    LineDiv_2 = 5,
    LineDiv_3 = 6,
  }
  export enum CtlNum {
    Volume = 1,
    Type = 2,
    Freq = 3,
    FreqFinetune = 4,
    FreqScale = 5,
    ExponentialFreq = 6,
    Q = 7,
    Gain = 8,
    RollOff = 9,
    Response = 10,
    Mode = 11,
    Mix = 12,
    LfoFreq = 13,
    LfoAmp = 14,
    LfoWaveform = 15,
    SetLfoPhase = 16,
    LfoFreqUnit = 17,
  }
  interface FilterProControllerMidiMaps extends ControllerMidiMaps {
    volume: ControllerMidiMap
    type: ControllerMidiMap
    freq: ControllerMidiMap
    freqFinetune: ControllerMidiMap
    freqScale: ControllerMidiMap
    exponentialFreq: ControllerMidiMap
    q: ControllerMidiMap
    gain: ControllerMidiMap
    rollOff: ControllerMidiMap
    response: ControllerMidiMap
    mode: ControllerMidiMap
    mix: ControllerMidiMap
    lfoFreq: ControllerMidiMap
    lfoAmp: ControllerMidiMap
    lfoWaveform: ControllerMidiMap
    setLfoPhase: ControllerMidiMap
    lfoFreqUnit: ControllerMidiMap
  }
  interface FilterProOptionValues extends OptionValues {}
  class FilterProOptions implements Options {
    constructor(readonly optionValues: FilterProOptionValues) {}
  }
  export class Module extends ModuleBase implements ModuleType {
    name = "Filter Pro"
    flags = 0x451
    readonly typeName = "Filter Pro"
    readonly controllerSetters = [
      (val: number) => {
        this.controllerValues.volume = val
      },
      (val: number) => {
        this.controllerValues.type = val
      },
      (val: number) => {
        this.controllerValues.freq = val
      },
      (val: number) => {
        this.controllerValues.freqFinetune = val
      },
      (val: number) => {
        this.controllerValues.freqScale = val
      },
      (val: number) => {
        this.controllerValues.exponentialFreq = Boolean(val)
      },
      (val: number) => {
        this.controllerValues.q = val
      },
      (val: number) => {
        this.controllerValues.gain = val
      },
      (val: number) => {
        this.controllerValues.rollOff = val
      },
      (val: number) => {
        this.controllerValues.response = val
      },
      (val: number) => {
        this.controllerValues.mode = val
      },
      (val: number) => {
        this.controllerValues.mix = val
      },
      (val: number) => {
        this.controllerValues.lfoFreq = val
      },
      (val: number) => {
        this.controllerValues.lfoAmp = val
      },
      (val: number) => {
        this.controllerValues.lfoWaveform = val
      },
      (val: number) => {
        this.controllerValues.setLfoPhase = val
      },
      (val: number) => {
        this.controllerValues.lfoFreqUnit = val
      },
    ]
    readonly controllerValues: FilterProControllerValues = {
      volume: 32768,
      type: Type.Lp,
      freq: 22000,
      freqFinetune: 0,
      freqScale: 100,
      exponentialFreq: false,
      q: 16384,
      gain: 0,
      rollOff: RollOff._12db,
      response: 250,
      mode: Mode.Stereo,
      mix: 32768,
      lfoFreq: 8,
      lfoAmp: 0,
      lfoWaveform: LfoWaveform.Sin,
      setLfoPhase: 0,
      lfoFreqUnit: LfoFreqUnit.HzMul_0_02,
    }
    readonly controllers: FilterProControllers = new FilterProControllers(
      this,
      this.controllerValues
    )
    readonly c = this.controllers
    readonly midiMaps: FilterProControllerMidiMaps = {
      volume: new ControllerMidiMap(),
      type: new ControllerMidiMap(),
      freq: new ControllerMidiMap(),
      freqFinetune: new ControllerMidiMap(),
      freqScale: new ControllerMidiMap(),
      exponentialFreq: new ControllerMidiMap(),
      q: new ControllerMidiMap(),
      gain: new ControllerMidiMap(),
      rollOff: new ControllerMidiMap(),
      response: new ControllerMidiMap(),
      mode: new ControllerMidiMap(),
      mix: new ControllerMidiMap(),
      lfoFreq: new ControllerMidiMap(),
      lfoAmp: new ControllerMidiMap(),
      lfoWaveform: new ControllerMidiMap(),
      setLfoPhase: new ControllerMidiMap(),
      lfoFreqUnit: new ControllerMidiMap(),
    }
    readonly optionValues: FilterProOptionValues = {}
    readonly options: FilterProOptions = new FilterProOptions(this.optionValues)
    readonly o = this.options
    behavior?: FilterProBehavior
    constructor() {
      super()
      this.behavior = new FilterProBehavior(this)
    }
    attachTo(project: Project): AttachedModule {
      return super.attachTo(project) as AttachedModule
    }
    setRawControllerValue(ctlNum: number, value: number) {
      const { controllerValues: cv } = this
      switch (ctlNum) {
        case 1:
          cv.volume = value
          break
        case 2:
          cv.type = value
          break
        case 3:
          cv.freq = value
          break
        case 4:
          cv.freqFinetune = value
          break
        case 5:
          cv.freqScale = value
          break
        case 6:
          cv.exponentialFreq = Boolean(value)
          break
        case 7:
          cv.q = value
          break
        case 8:
          cv.gain = value
          break
        case 9:
          cv.rollOff = value
          break
        case 10:
          cv.response = value
          break
        case 11:
          cv.mode = value
          break
        case 12:
          cv.mix = value
          break
        case 13:
          cv.lfoFreq = value
          break
        case 14:
          cv.lfoAmp = value
          break
        case 15:
          cv.lfoWaveform = value
          break
        case 16:
          cv.setLfoPhase = value
          break
        case 17:
          cv.lfoFreqUnit = value
          break
      }
    }
    *rawControllerValues(): Generator<number> {
      const { controllerValues: cv } = this
      yield cv.volume
      yield cv.type
      yield cv.freq
      yield cv.freqFinetune
      yield cv.freqScale
      yield Number(cv.exponentialFreq)
      yield cv.q
      yield cv.gain
      yield cv.rollOff
      yield cv.response
      yield cv.mode
      yield cv.mix
      yield cv.lfoFreq
      yield cv.lfoAmp
      yield cv.lfoWaveform
      yield cv.setLfoPhase
      yield cv.lfoFreqUnit
    }
    setMidiMaps(midiMaps: MidiMap[]) {
      this.midiMaps.volume = midiMaps[0] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.type = midiMaps[1] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.freq = midiMaps[2] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.freqFinetune = midiMaps[3] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.freqScale = midiMaps[4] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.exponentialFreq = midiMaps[5] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.q = midiMaps[6] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.gain = midiMaps[7] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.rollOff = midiMaps[8] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.response = midiMaps[9] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.mode = midiMaps[10] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.mix = midiMaps[11] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.lfoFreq = midiMaps[12] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.lfoAmp = midiMaps[13] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.lfoWaveform = midiMaps[14] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.setLfoPhase = midiMaps[15] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.lfoFreqUnit = midiMaps[16] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
    }
    midiMapsArray(): MidiMap[] {
      const a: MidiMap[] = []
      a.push(this.midiMaps.volume)
      a.push(this.midiMaps.type)
      a.push(this.midiMaps.freq)
      a.push(this.midiMaps.freqFinetune)
      a.push(this.midiMaps.freqScale)
      a.push(this.midiMaps.exponentialFreq)
      a.push(this.midiMaps.q)
      a.push(this.midiMaps.gain)
      a.push(this.midiMaps.rollOff)
      a.push(this.midiMaps.response)
      a.push(this.midiMaps.mode)
      a.push(this.midiMaps.mix)
      a.push(this.midiMaps.lfoFreq)
      a.push(this.midiMaps.lfoAmp)
      a.push(this.midiMaps.lfoWaveform)
      a.push(this.midiMaps.setLfoPhase)
      a.push(this.midiMaps.lfoFreqUnit)
      return a
    }
  }
  export class AttachedModule extends Module {
    get index(): number {
      if (this._index === undefined) {
        throw new Error("Attached module has empty index")
      }
      return this._index
    }
    set index(_: number) {
      throw new Error("Module index can only be assigned once")
    }
  }
}
