/**
 * -- DO NOT EDIT THIS FILE DIRECTLY --
 *
 * This file was auto-generated by genrv.
 */
import { MidiMap, ControllerMidiMap, ControllerMidiMaps } from "../controllerMidiMap"
import { Project } from "../project"
import { ModuleBase } from "./moduleBase"
import { ModuleType, OptionValues, Options } from "./moduleType"
import { GeneratorBehavior } from "./generatorBehavior"
import { GeneratorControllers } from "./generatorControllers"
import { GeneratorControllerValues } from "./generatorControllerValues"
export namespace Generator {
  // Intentionally duplicated enums - see also generatorEnums.ts
  // (TypeScript does not allow exporting imported enums from inside a namespace)
  export enum Waveform {
    // noinspection JSUnusedGlobalSymbols
    Triangle = 0,
    Saw = 1,
    Square = 2,
    Noise = 3,
    Drawn = 4,
    Sin = 5,
    Hsin = 6,
    Asin = 7,
    Psin = 8,
  }
  export enum Mode {
    // noinspection JSUnusedGlobalSymbols
    Stereo = 0,
    Mono = 1,
  }
  export enum CtlNum {
    Volume = 1,
    Waveform = 2,
    Panning = 3,
    Attack = 4,
    Release = 5,
    Polyphony = 6,
    Mode = 7,
    Sustain = 8,
    FreqModulationByInput = 9,
    DutyCycle = 10,
  }
  interface GeneratorControllerMidiMaps extends ControllerMidiMaps {
    volume: ControllerMidiMap
    waveform: ControllerMidiMap
    panning: ControllerMidiMap
    attack: ControllerMidiMap
    release: ControllerMidiMap
    polyphony: ControllerMidiMap
    mode: ControllerMidiMap
    sustain: ControllerMidiMap
    freqModulationByInput: ControllerMidiMap
    dutyCycle: ControllerMidiMap
  }
  interface GeneratorOptionValues extends OptionValues {}
  class GeneratorOptions implements Options {
    constructor(readonly optionValues: GeneratorOptionValues) {}
  }
  export class Module extends ModuleBase implements ModuleType {
    name = "Generator"
    flags = 0x59
    readonly typeName = "Generator"
    readonly controllerSetters = [
      (val: number) => {
        this.controllerValues.volume = val
      },
      (val: number) => {
        this.controllerValues.waveform = val
      },
      (val: number) => {
        this.controllerValues.panning = val
      },
      (val: number) => {
        this.controllerValues.attack = val
      },
      (val: number) => {
        this.controllerValues.release = val
      },
      (val: number) => {
        this.controllerValues.polyphony = val
      },
      (val: number) => {
        this.controllerValues.mode = val
      },
      (val: number) => {
        this.controllerValues.sustain = Boolean(val)
      },
      (val: number) => {
        this.controllerValues.freqModulationByInput = val
      },
      (val: number) => {
        this.controllerValues.dutyCycle = val
      },
    ]
    readonly controllerValues: GeneratorControllerValues = {
      volume: 128,
      waveform: Waveform.Triangle,
      panning: 0,
      attack: 0,
      release: 0,
      polyphony: 8,
      mode: Mode.Mono,
      sustain: true,
      freqModulationByInput: 0,
      dutyCycle: 511,
    }
    readonly controllers: GeneratorControllers = new GeneratorControllers(
      this,
      this.controllerValues
    )
    readonly c = this.controllers
    readonly midiMaps: GeneratorControllerMidiMaps = {
      volume: new ControllerMidiMap(),
      waveform: new ControllerMidiMap(),
      panning: new ControllerMidiMap(),
      attack: new ControllerMidiMap(),
      release: new ControllerMidiMap(),
      polyphony: new ControllerMidiMap(),
      mode: new ControllerMidiMap(),
      sustain: new ControllerMidiMap(),
      freqModulationByInput: new ControllerMidiMap(),
      dutyCycle: new ControllerMidiMap(),
    }
    readonly optionValues: GeneratorOptionValues = {}
    readonly options: GeneratorOptions = new GeneratorOptions(this.optionValues)
    readonly o = this.options
    behavior?: GeneratorBehavior
    constructor() {
      super()
      this.behavior = new GeneratorBehavior(this)
    }
    attachTo(project: Project): AttachedModule {
      return super.attachTo(project) as AttachedModule
    }
    setRawControllerValue(ctlNum: number, value: number) {
      const { controllerValues: cv } = this
      switch (ctlNum) {
        case 1:
          cv.volume = value
          break
        case 2:
          cv.waveform = value
          break
        case 3:
          cv.panning = value
          break
        case 4:
          cv.attack = value
          break
        case 5:
          cv.release = value
          break
        case 6:
          cv.polyphony = value
          break
        case 7:
          cv.mode = value
          break
        case 8:
          cv.sustain = Boolean(value)
          break
        case 9:
          cv.freqModulationByInput = value
          break
        case 10:
          cv.dutyCycle = value
          break
      }
    }
    *rawControllerValues(): Generator<number> {
      const { controllerValues: cv } = this
      yield cv.volume
      yield cv.waveform
      yield cv.panning
      yield cv.attack
      yield cv.release
      yield cv.polyphony
      yield cv.mode
      yield Number(cv.sustain)
      yield cv.freqModulationByInput
      yield cv.dutyCycle
    }
    setMidiMaps(midiMaps: MidiMap[]) {
      this.midiMaps.volume = midiMaps[0] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.waveform = midiMaps[1] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.panning = midiMaps[2] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.attack = midiMaps[3] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.release = midiMaps[4] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.polyphony = midiMaps[5] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.mode = midiMaps[6] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.sustain = midiMaps[7] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.freqModulationByInput = midiMaps[8] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.dutyCycle = midiMaps[9] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
    }
    midiMapsArray(): MidiMap[] {
      const a: MidiMap[] = []
      a.push(this.midiMaps.volume)
      a.push(this.midiMaps.waveform)
      a.push(this.midiMaps.panning)
      a.push(this.midiMaps.attack)
      a.push(this.midiMaps.release)
      a.push(this.midiMaps.polyphony)
      a.push(this.midiMaps.mode)
      a.push(this.midiMaps.sustain)
      a.push(this.midiMaps.freqModulationByInput)
      a.push(this.midiMaps.dutyCycle)
      return a
    }
  }
  export class AttachedModule extends Module {
    get index(): number {
      if (this._index === undefined) {
        throw new Error("Attached module has empty index")
      }
      return this._index
    }
    set index(_: number) {
      throw new Error("Module index can only be assigned once")
    }
  }
}
