/**
 * -- DO NOT EDIT THIS FILE DIRECTLY --
 *
 * This file was auto-generated by genrv.
 */
import { Controllers, ModuleType } from "./moduleType"
import { LfoControllerValues } from "./lfoControllerValues"
// @ts-ignore
// noinspection ES6UnusedImports
import { Type } from "./lfoEnums"
// @ts-ignore
// noinspection ES6UnusedImports
import { Waveform } from "./lfoEnums"
// @ts-ignore
// noinspection ES6UnusedImports
import { Channels } from "./lfoEnums"
// @ts-ignore
// noinspection ES6UnusedImports
import { FrequencyUnit } from "./lfoEnums"
// @ts-ignore
// noinspection ES6UnusedImports
import { SmoothTransitions } from "./lfoEnums"
// @ts-ignore
// noinspection ES6UnusedImports
import { SineQuality } from "./lfoEnums"
export class LfoBaseControllers implements Controllers {
  constructor(
    readonly module: ModuleType,
    readonly controllerValues: LfoControllerValues
  ) {}
  // noinspection JSUnusedGlobalSymbols
  get volume(): number {
    return this.controllerValues.volume
  }
  // noinspection JSUnusedGlobalSymbols
  set volume(newValue: number) {
    const { controllerValues } = this
    newValue = Math.min(Math.max(newValue, 0), 512)
    controllerValues.volume = newValue
  }
  // noinspection JSUnusedGlobalSymbols
  get type(): Type {
    return this.controllerValues.type
  }
  // noinspection JSUnusedGlobalSymbols
  set type(newValue: Type) {
    const { controllerValues } = this
    controllerValues.type = newValue
  }
  // noinspection JSUnusedGlobalSymbols
  get amplitude(): number {
    return this.controllerValues.amplitude
  }
  // noinspection JSUnusedGlobalSymbols
  set amplitude(newValue: number) {
    const { controllerValues } = this
    newValue = Math.min(Math.max(newValue, 0), 256)
    controllerValues.amplitude = newValue
  }
  // noinspection JSUnusedGlobalSymbols
  get freq(): number {
    return this.controllerValues.freq
  }
  // noinspection JSUnusedGlobalSymbols
  set freq(newValue: number) {
    const { controllerValues } = this
    switch (this.controllerValues.frequencyUnit) {
      case FrequencyUnit.HzDiv_64:
        newValue = Math.min(Math.max(newValue, 1), 2048)
        break
      case FrequencyUnit.Ms:
        newValue = Math.min(Math.max(newValue, 1), 4000)
        break
      case FrequencyUnit.Hz:
        newValue = Math.min(Math.max(newValue, 1), 16384)
        break
      case FrequencyUnit.Tick:
        newValue = Math.min(Math.max(newValue, 1), 256)
        break
      case FrequencyUnit.Line:
        newValue = Math.min(Math.max(newValue, 1), 256)
        break
      case FrequencyUnit.LineDiv_2:
        newValue = Math.min(Math.max(newValue, 1), 256)
        break
      case FrequencyUnit.LineDiv_3:
        newValue = Math.min(Math.max(newValue, 1), 256)
        break
    }
    controllerValues.freq = newValue
  }
  // noinspection JSUnusedGlobalSymbols
  get waveform(): Waveform {
    return this.controllerValues.waveform
  }
  // noinspection JSUnusedGlobalSymbols
  set waveform(newValue: Waveform) {
    const { controllerValues } = this
    controllerValues.waveform = newValue
  }
  // noinspection JSUnusedGlobalSymbols
  get setPhase(): number {
    return this.controllerValues.setPhase
  }
  // noinspection JSUnusedGlobalSymbols
  set setPhase(newValue: number) {
    const { controllerValues } = this
    newValue = Math.min(Math.max(newValue, 0), 256)
    controllerValues.setPhase = newValue
  }
  // noinspection JSUnusedGlobalSymbols
  get channels(): Channels {
    return this.controllerValues.channels
  }
  // noinspection JSUnusedGlobalSymbols
  set channels(newValue: Channels) {
    const { controllerValues } = this
    controllerValues.channels = newValue
  }
  // noinspection JSUnusedGlobalSymbols
  get frequencyUnit(): FrequencyUnit {
    return this.controllerValues.frequencyUnit
  }
  // noinspection JSUnusedGlobalSymbols
  set frequencyUnit(newValue: FrequencyUnit) {
    const { controllerValues } = this
    controllerValues.frequencyUnit = newValue
    this.freq = this.freq
  }
  // noinspection JSUnusedGlobalSymbols
  get dutyCycle(): number {
    return this.controllerValues.dutyCycle
  }
  // noinspection JSUnusedGlobalSymbols
  set dutyCycle(newValue: number) {
    const { controllerValues } = this
    newValue = Math.min(Math.max(newValue, 0), 256)
    controllerValues.dutyCycle = newValue
  }
  // noinspection JSUnusedGlobalSymbols
  get generator(): boolean {
    return this.controllerValues.generator
  }
  // noinspection JSUnusedGlobalSymbols
  set generator(newValue: boolean) {
    const { controllerValues } = this
    controllerValues.generator = newValue
  }
  // noinspection JSUnusedGlobalSymbols
  get freqScale(): number {
    return this.controllerValues.freqScale
  }
  // noinspection JSUnusedGlobalSymbols
  set freqScale(newValue: number) {
    const { controllerValues } = this
    newValue = Math.min(Math.max(newValue, 0), 200)
    controllerValues.freqScale = newValue
  }
  // noinspection JSUnusedGlobalSymbols
  get smoothTransitions(): SmoothTransitions {
    return this.controllerValues.smoothTransitions
  }
  // noinspection JSUnusedGlobalSymbols
  set smoothTransitions(newValue: SmoothTransitions) {
    const { controllerValues } = this
    controllerValues.smoothTransitions = newValue
  }
  // noinspection JSUnusedGlobalSymbols
  get sineQuality(): SineQuality {
    return this.controllerValues.sineQuality
  }
  // noinspection JSUnusedGlobalSymbols
  set sineQuality(newValue: SineQuality) {
    const { controllerValues } = this
    controllerValues.sineQuality = newValue
  }
}
