/**
 * -- DO NOT EDIT THIS FILE DIRECTLY --
 *
 * This file was auto-generated by genrv.
 */
import { ModuleDataChunks } from "../moduleDataChunk"
import { MidiMap, ControllerMidiMap, ControllerMidiMaps } from "../controllerMidiMap"
import { Project } from "../project"
import { ModuleBase } from "./moduleBase"
import { ModuleType, OptionValues, Options } from "./moduleType"
import { MetaModuleBehavior } from "./metaModuleBehavior"
import { MetaModuleControllers } from "./metaModuleControllers"
import { MetaModuleControllerValues } from "./metaModuleControllerValues"
export namespace MetaModule {
  // Intentionally duplicated enums - see also metaModuleEnums.ts
  // (TypeScript does not allow exporting imported enums from inside a namespace)
  export enum PlayPatterns {
    // noinspection JSUnusedGlobalSymbols
    Off = 0,
    OnRepeat = 1,
    OnNoRepeat = 2,
    OnRepeatEndless = 3,
    OnNoRepeatEndless = 4,
  }
  export enum CtlNum {
    Volume = 1,
    InputModule = 2,
    PlayPatterns = 3,
    Bpm = 4,
    Tpl = 5,
  }
  interface MetaModuleControllerMidiMaps extends ControllerMidiMaps {
    volume: ControllerMidiMap
    inputModule: ControllerMidiMap
    playPatterns: ControllerMidiMap
    bpm: ControllerMidiMap
    tpl: ControllerMidiMap
  }
  interface MetaModuleOptionValues extends OptionValues {
    userDefinedControllers: number
    arpeggiator: boolean
    applyVelocityToProject: boolean
    eventOutput: boolean
    receiveNotesFromKeyboard: boolean
    doNotReceiveNotesFromKeyboard: boolean
    autoBpmTpl: boolean
    ignoreEff_31AfterLastNoteOff: boolean
    jumpToRlPatternAfterLastNoteOff: boolean
    dummy5: boolean
    dummy6: boolean
    dummy7: boolean
  }
  class MetaModuleOptions implements Options {
    constructor(readonly optionValues: MetaModuleOptionValues) {}
    // noinspection JSUnusedGlobalSymbols
    get userDefinedControllers(): number {
      return this.optionValues.userDefinedControllers
    }
    // noinspection JSUnusedGlobalSymbols
    set userDefinedControllers(newValue: number) {
      if (newValue < 0 || newValue > 96) {
        throw new Error("Option value is out of range")
      }
      this.optionValues.userDefinedControllers = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get arpeggiator(): boolean {
      return this.optionValues.arpeggiator
    }
    // noinspection JSUnusedGlobalSymbols
    set arpeggiator(newValue: boolean) {
      this.optionValues.arpeggiator = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get applyVelocityToProject(): boolean {
      return this.optionValues.applyVelocityToProject
    }
    // noinspection JSUnusedGlobalSymbols
    set applyVelocityToProject(newValue: boolean) {
      this.optionValues.applyVelocityToProject = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get eventOutput(): boolean {
      return this.optionValues.eventOutput
    }
    // noinspection JSUnusedGlobalSymbols
    set eventOutput(newValue: boolean) {
      this.optionValues.eventOutput = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get receiveNotesFromKeyboard(): boolean {
      return this.optionValues.receiveNotesFromKeyboard
    }
    // noinspection JSUnusedGlobalSymbols
    set receiveNotesFromKeyboard(newValue: boolean) {
      this.optionValues.receiveNotesFromKeyboard = newValue
      this.optionValues.doNotReceiveNotesFromKeyboard = false
    }
    // noinspection JSUnusedGlobalSymbols
    get doNotReceiveNotesFromKeyboard(): boolean {
      return this.optionValues.doNotReceiveNotesFromKeyboard
    }
    // noinspection JSUnusedGlobalSymbols
    set doNotReceiveNotesFromKeyboard(newValue: boolean) {
      this.optionValues.doNotReceiveNotesFromKeyboard = newValue
      this.optionValues.receiveNotesFromKeyboard = false
    }
    // noinspection JSUnusedGlobalSymbols
    get autoBpmTpl(): boolean {
      return this.optionValues.autoBpmTpl
    }
    // noinspection JSUnusedGlobalSymbols
    set autoBpmTpl(newValue: boolean) {
      this.optionValues.autoBpmTpl = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get ignoreEff_31AfterLastNoteOff(): boolean {
      return this.optionValues.ignoreEff_31AfterLastNoteOff
    }
    // noinspection JSUnusedGlobalSymbols
    set ignoreEff_31AfterLastNoteOff(newValue: boolean) {
      this.optionValues.ignoreEff_31AfterLastNoteOff = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get jumpToRlPatternAfterLastNoteOff(): boolean {
      return this.optionValues.jumpToRlPatternAfterLastNoteOff
    }
    // noinspection JSUnusedGlobalSymbols
    set jumpToRlPatternAfterLastNoteOff(newValue: boolean) {
      this.optionValues.jumpToRlPatternAfterLastNoteOff = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get dummy5(): boolean {
      return this.optionValues.dummy5
    }
    // noinspection JSUnusedGlobalSymbols
    set dummy5(newValue: boolean) {
      this.optionValues.dummy5 = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get dummy6(): boolean {
      return this.optionValues.dummy6
    }
    // noinspection JSUnusedGlobalSymbols
    set dummy6(newValue: boolean) {
      this.optionValues.dummy6 = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get dummy7(): boolean {
      return this.optionValues.dummy7
    }
    // noinspection JSUnusedGlobalSymbols
    set dummy7(newValue: boolean) {
      this.optionValues.dummy7 = newValue
    }
  }
  export class Module extends ModuleBase implements ModuleType {
    name = "MetaModule"
    flags = 0x8051
    readonly typeName = "MetaModule"
    readonly optionsChnm = 2
    readonly controllerSetters = [
      (val: number) => {
        this.controllerValues.volume = val
      },
      (val: number) => {
        this.controllerValues.inputModule = val
      },
      (val: number) => {
        this.controllerValues.playPatterns = val
      },
      (val: number) => {
        this.controllerValues.bpm = val
      },
      (val: number) => {
        this.controllerValues.tpl = val
      },
    ]
    readonly controllerValues: MetaModuleControllerValues = {
      volume: 256,
      inputModule: 1,
      playPatterns: PlayPatterns.Off,
      bpm: 125,
      tpl: 6,
    }
    readonly controllers: MetaModuleControllers = new MetaModuleControllers(
      this,
      this.controllerValues
    )
    readonly c = this.controllers
    readonly midiMaps: MetaModuleControllerMidiMaps = {
      volume: new ControllerMidiMap(),
      inputModule: new ControllerMidiMap(),
      playPatterns: new ControllerMidiMap(),
      bpm: new ControllerMidiMap(),
      tpl: new ControllerMidiMap(),
    }
    readonly optionValues: MetaModuleOptionValues = {
      userDefinedControllers: 0,
      arpeggiator: false,
      applyVelocityToProject: false,
      eventOutput: true,
      receiveNotesFromKeyboard: false,
      doNotReceiveNotesFromKeyboard: false,
      autoBpmTpl: false,
      ignoreEff_31AfterLastNoteOff: false,
      jumpToRlPatternAfterLastNoteOff: false,
      dummy5: false,
      dummy6: false,
      dummy7: false,
    }
    readonly options: MetaModuleOptions = new MetaModuleOptions(this.optionValues)
    readonly o = this.options
    behavior?: MetaModuleBehavior
    constructor() {
      super()
      this.behavior = new MetaModuleBehavior(this)
    }
    attachTo(project: Project): AttachedModule {
      return super.attachTo(project) as AttachedModule
    }
    setRawControllerValue(ctlNum: number, value: number) {
      const { controllerValues: cv } = this
      switch (ctlNum) {
        case 1:
          cv.volume = value
          break
        case 2:
          cv.inputModule = value
          break
        case 3:
          cv.playPatterns = value
          break
        case 4:
          cv.bpm = value
          break
        case 5:
          cv.tpl = value
          break
      }
    }
    *rawControllerValues(): Generator<number> {
      const { controllerValues: cv } = this
      yield cv.volume
      yield cv.inputModule
      yield cv.playPatterns
      yield cv.bpm
      yield cv.tpl
    }
    setMidiMaps(midiMaps: MidiMap[]) {
      this.midiMaps.volume = midiMaps[0] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.inputModule = midiMaps[1] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.playPatterns = midiMaps[2] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.bpm = midiMaps[3] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.tpl = midiMaps[4] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
    }
    midiMapsArray(): MidiMap[] {
      const a: MidiMap[] = []
      a.push(this.midiMaps.volume)
      a.push(this.midiMaps.inputModule)
      a.push(this.midiMaps.playPatterns)
      a.push(this.midiMaps.bpm)
      a.push(this.midiMaps.tpl)
      return a
    }
    rawOptionBytes(): Uint8Array {
      const bytes = new Uint8Array(12)
      const { optionValues: ov } = this
      bytes[0] |= (Number(ov.userDefinedControllers) & (2 ** 8 - 1)) << 0
      bytes[1] |= (Number(ov.arpeggiator) & (2 ** 1 - 1)) << 0
      bytes[2] |= (Number(ov.applyVelocityToProject) & (2 ** 1 - 1)) << 0
      bytes[3] |= (Number(!ov.eventOutput) & (2 ** 1 - 1)) << 0
      bytes[4] |= (Number(ov.receiveNotesFromKeyboard) & (2 ** 1 - 1)) << 0
      bytes[4] |= (Number(ov.doNotReceiveNotesFromKeyboard) & (2 ** 1 - 1)) << 1
      bytes[4] |= (Number(ov.autoBpmTpl) & (2 ** 1 - 1)) << 2
      bytes[4] |= (Number(ov.ignoreEff_31AfterLastNoteOff) & (2 ** 1 - 1)) << 3
      bytes[4] |= (Number(ov.jumpToRlPatternAfterLastNoteOff) & (2 ** 1 - 1)) << 4
      bytes[5] |= (Number(ov.dummy5) & (2 ** 1 - 1)) << 0
      bytes[6] |= (Number(ov.dummy6) & (2 ** 1 - 1)) << 0
      bytes[7] |= (Number(ov.dummy7) & (2 ** 1 - 1)) << 0
      return bytes
    }
    setOptions(dataChunks: ModuleDataChunks) {
      let chdt
      for (const dataChunk of dataChunks) {
        if (dataChunk.chnm == this.optionsChnm) {
          chdt = dataChunk.chdt
          break
        }
      }
      if (chdt) {
        this.optionValues.userDefinedControllers = (chdt[0] >> 0) & (2 ** 8 - 1)
        this.optionValues.arpeggiator = Boolean((chdt[1] >> 0) & (2 ** 1 - 1))
        this.optionValues.applyVelocityToProject = Boolean(
          (chdt[2] >> 0) & (2 ** 1 - 1)
        )
        this.optionValues.eventOutput = !Boolean((chdt[3] >> 0) & (2 ** 1 - 1))
        this.optionValues.receiveNotesFromKeyboard = Boolean(
          (chdt[4] >> 0) & (2 ** 1 - 1)
        )
        this.optionValues.doNotReceiveNotesFromKeyboard = Boolean(
          (chdt[4] >> 1) & (2 ** 1 - 1)
        )
        this.optionValues.autoBpmTpl = Boolean((chdt[4] >> 2) & (2 ** 1 - 1))
        this.optionValues.ignoreEff_31AfterLastNoteOff = Boolean(
          (chdt[4] >> 3) & (2 ** 1 - 1)
        )
        this.optionValues.jumpToRlPatternAfterLastNoteOff = Boolean(
          (chdt[4] >> 4) & (2 ** 1 - 1)
        )
        this.optionValues.dummy5 = Boolean((chdt[5] >> 0) & (2 ** 1 - 1))
        this.optionValues.dummy6 = Boolean((chdt[6] >> 0) & (2 ** 1 - 1))
        this.optionValues.dummy7 = Boolean((chdt[7] >> 0) & (2 ** 1 - 1))
      }
    }
  }
  export class AttachedModule extends Module {
    get index(): number {
      if (this._index === undefined) {
        throw new Error("Attached module has empty index")
      }
      return this._index
    }
    set index(_: number) {
      throw new Error("Module index can only be assigned once")
    }
  }
}
