/**
 * -- DO NOT EDIT THIS FILE DIRECTLY --
 *
 * This file was auto-generated by genrv.
 */
import { MidiMap, ControllerMidiMap, ControllerMidiMaps } from "../controllerMidiMap"
import { Project } from "../project"
import { ModuleBase } from "./moduleBase"
import { ModuleType, OptionValues, Options } from "./moduleType"
import { ModulatorBehavior } from "./modulatorBehavior"
import { ModulatorControllers } from "./modulatorControllers"
import { ModulatorControllerValues } from "./modulatorControllerValues"
export namespace Modulator {
  // Intentionally duplicated enums - see also modulatorEnums.ts
  // (TypeScript does not allow exporting imported enums from inside a namespace)
  export enum ModulationType {
    // noinspection JSUnusedGlobalSymbols
    Amplitude = 0,
    Phase = 1,
    PhaseAbs = 2,
    Add = 3,
    Sub = 4,
    Min = 5,
    Max = 6,
    BitwiseAnd = 7,
    BitwiseXor = 8,
    MinAbs = 9,
    MaxAbs = 10,
  }
  export enum Channels {
    // noinspection JSUnusedGlobalSymbols
    Stereo = 0,
    Mono = 1,
  }
  export enum MaxPhaseModulationDelay {
    // noinspection JSUnusedGlobalSymbols
    Sec_0_04 = 0,
    Sec_0_08 = 1,
    Sec_0_2 = 2,
    Sec_0_5 = 3,
    Sec_1 = 4,
    Sec_2 = 5,
    Sec_4 = 6,
  }
  export enum CtlNum {
    Volume = 1,
    ModulationType = 2,
    Channels = 3,
    MaxPhaseModulationDelay = 4,
  }
  interface ModulatorControllerMidiMaps extends ControllerMidiMaps {
    volume: ControllerMidiMap
    modulationType: ControllerMidiMap
    channels: ControllerMidiMap
    maxPhaseModulationDelay: ControllerMidiMap
  }
  interface ModulatorOptionValues extends OptionValues {}
  class ModulatorOptions implements Options {
    constructor(readonly optionValues: ModulatorOptionValues) {}
  }
  export class Module extends ModuleBase implements ModuleType {
    name = "Modulator"
    flags = 0x2051
    readonly typeName = "Modulator"
    readonly controllerSetters = [
      (val: number) => {
        this.controllerValues.volume = val
      },
      (val: number) => {
        this.controllerValues.modulationType = val
      },
      (val: number) => {
        this.controllerValues.channels = val
      },
      (val: number) => {
        this.controllerValues.maxPhaseModulationDelay = val
      },
    ]
    readonly controllerValues: ModulatorControllerValues = {
      volume: 256,
      modulationType: ModulationType.Amplitude,
      channels: Channels.Stereo,
      maxPhaseModulationDelay: MaxPhaseModulationDelay.Sec_0_04,
    }
    readonly controllers: ModulatorControllers = new ModulatorControllers(
      this,
      this.controllerValues
    )
    readonly c = this.controllers
    readonly midiMaps: ModulatorControllerMidiMaps = {
      volume: new ControllerMidiMap(),
      modulationType: new ControllerMidiMap(),
      channels: new ControllerMidiMap(),
      maxPhaseModulationDelay: new ControllerMidiMap(),
    }
    readonly optionValues: ModulatorOptionValues = {}
    readonly options: ModulatorOptions = new ModulatorOptions(this.optionValues)
    readonly o = this.options
    behavior?: ModulatorBehavior
    constructor() {
      super()
      this.behavior = new ModulatorBehavior(this)
    }
    attachTo(project: Project): AttachedModule {
      return super.attachTo(project) as AttachedModule
    }
    setRawControllerValue(ctlNum: number, value: number) {
      const { controllerValues: cv } = this
      switch (ctlNum) {
        case 1:
          cv.volume = value
          break
        case 2:
          cv.modulationType = value
          break
        case 3:
          cv.channels = value
          break
        case 4:
          cv.maxPhaseModulationDelay = value
          break
      }
    }
    *rawControllerValues(): Generator<number> {
      const { controllerValues: cv } = this
      yield cv.volume
      yield cv.modulationType
      yield cv.channels
      yield cv.maxPhaseModulationDelay
    }
    setMidiMaps(midiMaps: MidiMap[]) {
      this.midiMaps.volume = midiMaps[0] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.modulationType = midiMaps[1] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.channels = midiMaps[2] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.maxPhaseModulationDelay = midiMaps[3] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
    }
    midiMapsArray(): MidiMap[] {
      const a: MidiMap[] = []
      a.push(this.midiMaps.volume)
      a.push(this.midiMaps.modulationType)
      a.push(this.midiMaps.channels)
      a.push(this.midiMaps.maxPhaseModulationDelay)
      return a
    }
  }
  export class AttachedModule extends Module {
    get index(): number {
      if (this._index === undefined) {
        throw new Error("Attached module has empty index")
      }
      return this._index
    }
    set index(_: number) {
      throw new Error("Module index can only be assigned once")
    }
  }
}
