/**
 * -- DO NOT EDIT THIS FILE DIRECTLY --
 *
 * This file was auto-generated by genrv.
 */
import { ModuleDataChunks } from "../moduleDataChunk"
import { MidiMap, ControllerMidiMap, ControllerMidiMaps } from "../controllerMidiMap"
import { Project } from "../project"
import { ModuleBase } from "./moduleBase"
import { ModuleType, OptionValues, Options } from "./moduleType"
import { SamplerBehavior } from "./samplerBehavior"
import { SamplerControllers } from "./samplerControllers"
import { SamplerControllerValues } from "./samplerControllerValues"
export namespace Sampler {
  // Intentionally duplicated enums - see also samplerEnums.ts
  // (TypeScript does not allow exporting imported enums from inside a namespace)
  export enum SampleInterpolation {
    // noinspection JSUnusedGlobalSymbols
    Off = 0,
    Linear = 1,
    Spline = 2,
  }
  export enum EnvelopeInterpolation {
    // noinspection JSUnusedGlobalSymbols
    Off = 0,
    Linear = 1,
  }
  export enum VibratoType {
    // noinspection JSUnusedGlobalSymbols
    Sin = 0,
    Saw = 1,
    Square = 2,
  }
  export enum LoopType {
    // noinspection JSUnusedGlobalSymbols
    Off = 0,
    Forward = 1,
    PingPong = 2,
  }
  export enum Format {
    // noinspection JSUnusedGlobalSymbols
    Int8 = 1,
    Int16 = 2,
    Float32 = 4,
  }
  export enum Channels {
    // noinspection JSUnusedGlobalSymbols
    Mono = 0,
    Stereo = 8,
  }
  export enum EnvelopeFlags {
    // noinspection JSUnusedGlobalSymbols
    Enabled = 1,
    Sustain = 2,
    Loop = 4,
  }
  export enum Record {
    // noinspection JSUnusedGlobalSymbols
    Stop = 0,
    Pause = 1,
    Start = 2,
  }
  export enum CtlNum {
    Volume = 1,
    Panning = 2,
    SampleInterpolation = 3,
    EnvelopeInterpolation = 4,
    Polyphony = 5,
    RecThreshold = 6,
    TickLength = 7,
    Record = 8,
  }
  interface SamplerControllerMidiMaps extends ControllerMidiMaps {
    volume: ControllerMidiMap
    panning: ControllerMidiMap
    sampleInterpolation: ControllerMidiMap
    envelopeInterpolation: ControllerMidiMap
    polyphony: ControllerMidiMap
    recThreshold: ControllerMidiMap
    tickLength: ControllerMidiMap
    record: ControllerMidiMap
  }
  interface SamplerOptionValues extends OptionValues {
    startRecordingOnProjectPlay: boolean
    recordInMono: boolean
    recordWithReducedSampleRate: boolean
    recordIn_16Bit: boolean
    stopRecordingOnProjectStop: boolean
    ignoreVelocityForVolume: boolean
    increasedFreqComputationAccuracy: boolean
    fitToPattern: boolean
  }
  class SamplerOptions implements Options {
    constructor(readonly optionValues: SamplerOptionValues) {}
    // noinspection JSUnusedGlobalSymbols
    get startRecordingOnProjectPlay(): boolean {
      return this.optionValues.startRecordingOnProjectPlay
    }
    // noinspection JSUnusedGlobalSymbols
    set startRecordingOnProjectPlay(newValue: boolean) {
      this.optionValues.startRecordingOnProjectPlay = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get recordInMono(): boolean {
      return this.optionValues.recordInMono
    }
    // noinspection JSUnusedGlobalSymbols
    set recordInMono(newValue: boolean) {
      this.optionValues.recordInMono = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get recordWithReducedSampleRate(): boolean {
      return this.optionValues.recordWithReducedSampleRate
    }
    // noinspection JSUnusedGlobalSymbols
    set recordWithReducedSampleRate(newValue: boolean) {
      this.optionValues.recordWithReducedSampleRate = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get recordIn_16Bit(): boolean {
      return this.optionValues.recordIn_16Bit
    }
    // noinspection JSUnusedGlobalSymbols
    set recordIn_16Bit(newValue: boolean) {
      this.optionValues.recordIn_16Bit = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get stopRecordingOnProjectStop(): boolean {
      return this.optionValues.stopRecordingOnProjectStop
    }
    // noinspection JSUnusedGlobalSymbols
    set stopRecordingOnProjectStop(newValue: boolean) {
      this.optionValues.stopRecordingOnProjectStop = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get ignoreVelocityForVolume(): boolean {
      return this.optionValues.ignoreVelocityForVolume
    }
    // noinspection JSUnusedGlobalSymbols
    set ignoreVelocityForVolume(newValue: boolean) {
      this.optionValues.ignoreVelocityForVolume = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get increasedFreqComputationAccuracy(): boolean {
      return this.optionValues.increasedFreqComputationAccuracy
    }
    // noinspection JSUnusedGlobalSymbols
    set increasedFreqComputationAccuracy(newValue: boolean) {
      this.optionValues.increasedFreqComputationAccuracy = newValue
    }
    // noinspection JSUnusedGlobalSymbols
    get fitToPattern(): boolean {
      return this.optionValues.fitToPattern
    }
    // noinspection JSUnusedGlobalSymbols
    set fitToPattern(newValue: boolean) {
      this.optionValues.fitToPattern = newValue
    }
  }
  export class Module extends ModuleBase implements ModuleType {
    name = "Sampler"
    flags = 0x8459
    readonly typeName = "Sampler"
    readonly optionsChnm = 257
    readonly controllerSetters = [
      (val: number) => {
        this.controllerValues.volume = val
      },
      (val: number) => {
        this.controllerValues.panning = val
      },
      (val: number) => {
        this.controllerValues.sampleInterpolation = val
      },
      (val: number) => {
        this.controllerValues.envelopeInterpolation = val
      },
      (val: number) => {
        this.controllerValues.polyphony = val
      },
      (val: number) => {
        this.controllerValues.recThreshold = val
      },
      (val: number) => {
        this.controllerValues.tickLength = val
      },
      (val: number) => {
        this.controllerValues.record = val
      },
    ]
    readonly controllerValues: SamplerControllerValues = {
      volume: 256,
      panning: 0,
      sampleInterpolation: SampleInterpolation.Spline,
      envelopeInterpolation: EnvelopeInterpolation.Linear,
      polyphony: 8,
      recThreshold: 4,
      tickLength: 128,
      record: Record.Stop,
    }
    readonly controllers: SamplerControllers = new SamplerControllers(
      this,
      this.controllerValues
    )
    readonly c = this.controllers
    readonly midiMaps: SamplerControllerMidiMaps = {
      volume: new ControllerMidiMap(),
      panning: new ControllerMidiMap(),
      sampleInterpolation: new ControllerMidiMap(),
      envelopeInterpolation: new ControllerMidiMap(),
      polyphony: new ControllerMidiMap(),
      recThreshold: new ControllerMidiMap(),
      tickLength: new ControllerMidiMap(),
      record: new ControllerMidiMap(),
    }
    readonly optionValues: SamplerOptionValues = {
      startRecordingOnProjectPlay: false,
      recordInMono: false,
      recordWithReducedSampleRate: false,
      recordIn_16Bit: false,
      stopRecordingOnProjectStop: false,
      ignoreVelocityForVolume: false,
      increasedFreqComputationAccuracy: false,
      fitToPattern: false,
    }
    readonly options: SamplerOptions = new SamplerOptions(this.optionValues)
    readonly o = this.options
    behavior?: SamplerBehavior
    constructor() {
      super()
      this.behavior = new SamplerBehavior(this)
    }
    attachTo(project: Project): AttachedModule {
      return super.attachTo(project) as AttachedModule
    }
    setRawControllerValue(ctlNum: number, value: number) {
      const { controllerValues: cv } = this
      switch (ctlNum) {
        case 1:
          cv.volume = value
          break
        case 2:
          cv.panning = value
          break
        case 3:
          cv.sampleInterpolation = value
          break
        case 4:
          cv.envelopeInterpolation = value
          break
        case 5:
          cv.polyphony = value
          break
        case 6:
          cv.recThreshold = value
          break
        case 7:
          cv.tickLength = value
          break
        case 8:
          cv.record = value
          break
      }
    }
    *rawControllerValues(): Generator<number> {
      const { controllerValues: cv } = this
      yield cv.volume
      yield cv.panning
      yield cv.sampleInterpolation
      yield cv.envelopeInterpolation
      yield cv.polyphony
      yield cv.recThreshold
      yield cv.tickLength
      yield cv.record
    }
    setMidiMaps(midiMaps: MidiMap[]) {
      this.midiMaps.volume = midiMaps[0] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.panning = midiMaps[1] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.sampleInterpolation = midiMaps[2] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.envelopeInterpolation = midiMaps[3] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.polyphony = midiMaps[4] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.recThreshold = midiMaps[5] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.tickLength = midiMaps[6] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.record = midiMaps[7] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
    }
    midiMapsArray(): MidiMap[] {
      const a: MidiMap[] = []
      a.push(this.midiMaps.volume)
      a.push(this.midiMaps.panning)
      a.push(this.midiMaps.sampleInterpolation)
      a.push(this.midiMaps.envelopeInterpolation)
      a.push(this.midiMaps.polyphony)
      a.push(this.midiMaps.recThreshold)
      a.push(this.midiMaps.tickLength)
      a.push(this.midiMaps.record)
      return a
    }
    rawOptionBytes(): Uint8Array {
      const bytes = new Uint8Array(8)
      const { optionValues: ov } = this
      bytes[0] |= (Number(ov.startRecordingOnProjectPlay) & (2 ** 1 - 1)) << 0
      bytes[1] |= (Number(ov.recordInMono) & (2 ** 1 - 1)) << 0
      bytes[2] |= (Number(ov.recordWithReducedSampleRate) & (2 ** 1 - 1)) << 0
      bytes[3] |= (Number(ov.recordIn_16Bit) & (2 ** 1 - 1)) << 0
      bytes[4] |= (Number(ov.stopRecordingOnProjectStop) & (2 ** 1 - 1)) << 0
      bytes[5] |= (Number(ov.ignoreVelocityForVolume) & (2 ** 1 - 1)) << 0
      bytes[6] |= (Number(ov.increasedFreqComputationAccuracy) & (2 ** 1 - 1)) << 0
      bytes[7] |= (Number(ov.fitToPattern) & (2 ** 8 - 1)) << 0
      return bytes
    }
    setOptions(dataChunks: ModuleDataChunks) {
      let chdt
      for (const dataChunk of dataChunks) {
        if (dataChunk.chnm == this.optionsChnm) {
          chdt = dataChunk.chdt
          break
        }
      }
      if (chdt) {
        this.optionValues.startRecordingOnProjectPlay = Boolean(
          (chdt[0] >> 0) & (2 ** 1 - 1)
        )
        this.optionValues.recordInMono = Boolean((chdt[1] >> 0) & (2 ** 1 - 1))
        this.optionValues.recordWithReducedSampleRate = Boolean(
          (chdt[2] >> 0) & (2 ** 1 - 1)
        )
        this.optionValues.recordIn_16Bit = Boolean((chdt[3] >> 0) & (2 ** 1 - 1))
        this.optionValues.stopRecordingOnProjectStop = Boolean(
          (chdt[4] >> 0) & (2 ** 1 - 1)
        )
        this.optionValues.ignoreVelocityForVolume = Boolean(
          (chdt[5] >> 0) & (2 ** 1 - 1)
        )
        this.optionValues.increasedFreqComputationAccuracy = Boolean(
          (chdt[6] >> 0) & (2 ** 1 - 1)
        )
        this.optionValues.fitToPattern = (chdt[7] >> 0) & (2 ** 8 - 1)
      }
    }
  }
  export class AttachedModule extends Module {
    get index(): number {
      if (this._index === undefined) {
        throw new Error("Attached module has empty index")
      }
      return this._index
    }
    set index(_: number) {
      throw new Error("Module index can only be assigned once")
    }
  }
}
