/**
 * -- DO NOT EDIT THIS FILE DIRECTLY --
 *
 * This file was auto-generated by genrv.
 */
import { MidiMap, ControllerMidiMap, ControllerMidiMaps } from "../controllerMidiMap"
import { Project } from "../project"
import { ModuleBase } from "./moduleBase"
import { ModuleType, OptionValues, Options } from "./moduleType"
import { Velocity2CtlBehavior } from "./velocity2CtlBehavior"
import { Velocity2CtlControllers } from "./velocity2CtlControllers"
import { Velocity2CtlControllerValues } from "./velocity2CtlControllerValues"
export namespace Velocity2Ctl {
  // Intentionally duplicated enums - see also velocity2CtlEnums.ts
  // (TypeScript does not allow exporting imported enums from inside a namespace)
  export enum NoteOffAction {
    // noinspection JSUnusedGlobalSymbols
    DoNothing = 0,
    VelDown = 1,
    VelUp = 2,
  }
  export enum CtlNum {
    NoteOffAction = 1,
    OutMin = 2,
    OutMax = 3,
    OutOffset = 4,
    OutController = 5,
  }
  interface Velocity2CtlControllerMidiMaps extends ControllerMidiMaps {
    noteOffAction: ControllerMidiMap
    outMin: ControllerMidiMap
    outMax: ControllerMidiMap
    outOffset: ControllerMidiMap
    outController: ControllerMidiMap
  }
  interface Velocity2CtlOptionValues extends OptionValues {}
  class Velocity2CtlOptions implements Options {
    constructor(readonly optionValues: Velocity2CtlOptionValues) {}
  }
  export class Module extends ModuleBase implements ModuleType {
    name = "Velocity2Ctl"
    flags = 0x1020049
    readonly typeName = "Velocity2Ctl"
    readonly controllerSetters = [
      (val: number) => {
        this.controllerValues.noteOffAction = val
      },
      (val: number) => {
        this.controllerValues.outMin = val
      },
      (val: number) => {
        this.controllerValues.outMax = val
      },
      (val: number) => {
        this.controllerValues.outOffset = val
      },
      (val: number) => {
        this.controllerValues.outController = val
      },
    ]
    readonly controllerValues: Velocity2CtlControllerValues = {
      noteOffAction: NoteOffAction.DoNothing,
      outMin: 0,
      outMax: 32768,
      outOffset: 0,
      outController: 0,
    }
    readonly controllers: Velocity2CtlControllers = new Velocity2CtlControllers(
      this,
      this.controllerValues
    )
    readonly c = this.controllers
    readonly midiMaps: Velocity2CtlControllerMidiMaps = {
      noteOffAction: new ControllerMidiMap(),
      outMin: new ControllerMidiMap(),
      outMax: new ControllerMidiMap(),
      outOffset: new ControllerMidiMap(),
      outController: new ControllerMidiMap(),
    }
    readonly optionValues: Velocity2CtlOptionValues = {}
    readonly options: Velocity2CtlOptions = new Velocity2CtlOptions(this.optionValues)
    readonly o = this.options
    behavior?: Velocity2CtlBehavior
    constructor() {
      super()
      this.behavior = new Velocity2CtlBehavior(this)
    }
    attachTo(project: Project): AttachedModule {
      return super.attachTo(project) as AttachedModule
    }
    setRawControllerValue(ctlNum: number, value: number) {
      const { controllerValues: cv } = this
      switch (ctlNum) {
        case 1:
          cv.noteOffAction = value
          break
        case 2:
          cv.outMin = value
          break
        case 3:
          cv.outMax = value
          break
        case 4:
          cv.outOffset = value
          break
        case 5:
          cv.outController = value
          break
      }
    }
    *rawControllerValues(): Generator<number> {
      const { controllerValues: cv } = this
      yield cv.noteOffAction
      yield cv.outMin
      yield cv.outMax
      yield cv.outOffset
      yield cv.outController
    }
    setMidiMaps(midiMaps: MidiMap[]) {
      this.midiMaps.noteOffAction = midiMaps[0] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.outMin = midiMaps[1] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.outMax = midiMaps[2] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.outOffset = midiMaps[3] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.outController = midiMaps[4] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
    }
    midiMapsArray(): MidiMap[] {
      const a: MidiMap[] = []
      a.push(this.midiMaps.noteOffAction)
      a.push(this.midiMaps.outMin)
      a.push(this.midiMaps.outMax)
      a.push(this.midiMaps.outOffset)
      a.push(this.midiMaps.outController)
      return a
    }
  }
  export class AttachedModule extends Module {
    get index(): number {
      if (this._index === undefined) {
        throw new Error("Attached module has empty index")
      }
      return this._index
    }
    set index(_: number) {
      throw new Error("Module index can only be assigned once")
    }
  }
}
