/**
 * -- DO NOT EDIT THIS FILE DIRECTLY --
 *
 * This file was auto-generated by genrv.
 */
import { MidiMap, ControllerMidiMap, ControllerMidiMaps } from "../controllerMidiMap"
import { Project } from "../project"
import { ModuleBase } from "./moduleBase"
import { ModuleType, OptionValues, Options } from "./moduleType"
import { VorbisPlayerBehavior } from "./vorbisPlayerBehavior"
import { VorbisPlayerControllers } from "./vorbisPlayerControllers"
import { VorbisPlayerControllerValues } from "./vorbisPlayerControllerValues"
export namespace VorbisPlayer {
  export enum CtlNum {
    Volume = 1,
    OriginalSpeed = 2,
    Finetune = 3,
    Transpose = 4,
    Interpolation = 5,
    Polyphony = 6,
    Repeat = 7,
    IgnoreNoteOff = 8,
  }
  interface VorbisPlayerControllerMidiMaps extends ControllerMidiMaps {
    volume: ControllerMidiMap
    originalSpeed: ControllerMidiMap
    finetune: ControllerMidiMap
    transpose: ControllerMidiMap
    interpolation: ControllerMidiMap
    polyphony: ControllerMidiMap
    repeat: ControllerMidiMap
    ignoreNoteOff: ControllerMidiMap
  }
  interface VorbisPlayerOptionValues extends OptionValues {}
  class VorbisPlayerOptions implements Options {
    constructor(readonly optionValues: VorbisPlayerOptionValues) {}
  }
  export class Module extends ModuleBase implements ModuleType {
    name = "Vorbis player"
    flags = 0x8049
    readonly typeName = "Vorbis player"
    readonly controllerSetters = [
      (val: number) => {
        this.controllerValues.volume = val
      },
      (val: number) => {
        this.controllerValues.originalSpeed = Boolean(val)
      },
      (val: number) => {
        this.controllerValues.finetune = val
      },
      (val: number) => {
        this.controllerValues.transpose = val
      },
      (val: number) => {
        this.controllerValues.interpolation = Boolean(val)
      },
      (val: number) => {
        this.controllerValues.polyphony = val
      },
      (val: number) => {
        this.controllerValues.repeat = Boolean(val)
      },
      (val: number) => {
        this.controllerValues.ignoreNoteOff = Boolean(val)
      },
    ]
    readonly controllerValues: VorbisPlayerControllerValues = {
      volume: 256,
      originalSpeed: true,
      finetune: 0,
      transpose: 0,
      interpolation: true,
      polyphony: 1,
      repeat: false,
      ignoreNoteOff: false,
    }
    readonly controllers: VorbisPlayerControllers = new VorbisPlayerControllers(
      this,
      this.controllerValues
    )
    readonly c = this.controllers
    readonly midiMaps: VorbisPlayerControllerMidiMaps = {
      volume: new ControllerMidiMap(),
      originalSpeed: new ControllerMidiMap(),
      finetune: new ControllerMidiMap(),
      transpose: new ControllerMidiMap(),
      interpolation: new ControllerMidiMap(),
      polyphony: new ControllerMidiMap(),
      repeat: new ControllerMidiMap(),
      ignoreNoteOff: new ControllerMidiMap(),
    }
    readonly optionValues: VorbisPlayerOptionValues = {}
    readonly options: VorbisPlayerOptions = new VorbisPlayerOptions(this.optionValues)
    readonly o = this.options
    behavior?: VorbisPlayerBehavior
    constructor() {
      super()
      this.behavior = new VorbisPlayerBehavior(this)
    }
    attachTo(project: Project): AttachedModule {
      return super.attachTo(project) as AttachedModule
    }
    setRawControllerValue(ctlNum: number, value: number) {
      const { controllerValues: cv } = this
      switch (ctlNum) {
        case 1:
          cv.volume = value
          break
        case 2:
          cv.originalSpeed = Boolean(value)
          break
        case 3:
          cv.finetune = value
          break
        case 4:
          cv.transpose = value
          break
        case 5:
          cv.interpolation = Boolean(value)
          break
        case 6:
          cv.polyphony = value
          break
        case 7:
          cv.repeat = Boolean(value)
          break
        case 8:
          cv.ignoreNoteOff = Boolean(value)
          break
      }
    }
    *rawControllerValues(): Generator<number> {
      const { controllerValues: cv } = this
      yield cv.volume
      yield Number(cv.originalSpeed)
      yield cv.finetune
      yield cv.transpose
      yield Number(cv.interpolation)
      yield cv.polyphony
      yield Number(cv.repeat)
      yield Number(cv.ignoreNoteOff)
    }
    setMidiMaps(midiMaps: MidiMap[]) {
      this.midiMaps.volume = midiMaps[0] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.originalSpeed = midiMaps[1] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.finetune = midiMaps[2] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.transpose = midiMaps[3] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.interpolation = midiMaps[4] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.polyphony = midiMaps[5] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.repeat = midiMaps[6] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
      this.midiMaps.ignoreNoteOff = midiMaps[7] || {
        channel: 0,
        messageType: 0,
        messageParameter: 0,
        slope: 0,
      }
    }
    midiMapsArray(): MidiMap[] {
      const a: MidiMap[] = []
      a.push(this.midiMaps.volume)
      a.push(this.midiMaps.originalSpeed)
      a.push(this.midiMaps.finetune)
      a.push(this.midiMaps.transpose)
      a.push(this.midiMaps.interpolation)
      a.push(this.midiMaps.polyphony)
      a.push(this.midiMaps.repeat)
      a.push(this.midiMaps.ignoreNoteOff)
      return a
    }
  }
  export class AttachedModule extends Module {
    get index(): number {
      if (this._index === undefined) {
        throw new Error("Attached module has empty index")
      }
      return this._index
    }
    set index(_: number) {
      throw new Error("Module index can only be assigned once")
    }
  }
}
